/**********************************************************************************
 * Proiectarea cu Microprocesoare
 * Cristian RUTA 334CB
 *********************************************************************************/

#include <stdio.h>
#include <avr\io.h>
#include <avr\interrupt.h>
#define F_CPU 16000000
#include <util/delay.h>
#include <string.h>
#include "lcd.h"

//functie ce calculeaza tipul cablului introdus
int findType(int *v){ 
		
		int straight[8] = {8, 7, 6, 5, 4, 1, 3, 2};
		int cross[8] = {3, 6, 1, 4, 5, 2, 7, 8};
		int roll[8] = {2, 3, 1, 4, 5, 6, 7, 8};
		int i,ok = 0;
		
		for(i = 0; i < 8; i++){
			
			if(v[i] != straight[i]){
				
				ok = 1;
				break;
			}
		}
		
		if(ok == 0)
			return 0;
		
		ok = 0;
		
		for(i = 0; i < 8; i++){
			if(v[i] != cross[i]){
				ok = 1;
				break;
			}
		}

		if(ok == 0)
			return 1;
		
		ok = 0;
		
		for(i = 0; i < 8; i++){
			if(v[i] != roll[i]){
				ok = 1;
				break;
			}
		}
		
		if(ok == 0)
			return 2;
		
		return 3;
	}
	
void init_Ports(){
	//input port
	DDRA = 0xFF; 
	//Output port
	DDRB = 0x00; 
}

int check_pluged_in(){
		
		PORTA = 0xFF;
		_delay_ms(500);
		if(PINB == 0x00){
			
			return 0;
		}
	return 1;
}

int main()
{
	int i;
	LCD_init();

	LCD_print("UTPIntelliTester");
	_delay_ms(2000);
	
	LCD_print("PM2014");
	_delay_ms(2000);
	
	init_Ports();
	
	int j, type;
	int v[8] = {0, 0, 0, 0, 0, 0, 0, 0};
	while(1){
		
		int check_cable_ret;
		check_cable_ret = check_pluged_in();
		
		if (check_cable_ret == 0)
			LCD_print("Plug in cable");
		else{
			for(i=7; i>=0; i--) {
		 		PORTA = 1<<i;
				
		 		if(PINB == 0x00){ 
					LCD_print("Bad cable :(");
					break;
				}
				_delay_ms(1000);
				LCD_print("Testing Cable ...");
				for(j = 7; j >= 0; j--){
					if(bit_is_set(PINB, j)){
						v[i] = j + 1;
						
					}
				}
				if(i == 0){
					type = findType(v);
					if(type == 0){
						LCD_print("STRAIGHT cable.");
					}
					else{
						if(type == 1){
							LCD_print("CROSSOVER cable.");
						}
						else{
							if(type == 2){
								LCD_print("ROLLOVER cable.");
							}
							else{
								LCD_print("UNDEFINED cable.");
							}
						}
					}
					
					PORTA = 0x00;
					PORTC = 0x00;
					_delay_ms(1000);
					LCD_writeInstruction(LCD_INSTR_clearDisplay);
				}
			}
		}	
	}
	return 0;
}
